Index: tmp/org.txm.tigersearch.rcp/src/org/txm/searchengine/ts/TIGERSearchEngine.java
===================================================================
--- tmp/org.txm.tigersearch.rcp/src/org/txm/searchengine/ts/TIGERSearchEngine.java	(revision 3060)
+++ tmp/org.txm.tigersearch.rcp/src/org/txm/searchengine/ts/TIGERSearchEngine.java	(revision 3061)
@@ -27,6 +27,7 @@
 import org.txm.searchengine.cqp.corpus.CQPCorpus;
 import org.txm.searchengine.cqp.corpus.MainCorpus;
 import org.txm.searchengine.cqp.serverException.CqiServerError;
+import org.txm.tigersearch.rcp.preferences.TIGERSearchPreferences;
 import org.txm.utils.DeleteDir;
 import org.txm.utils.logger.Log;
 
@@ -35,11 +36,11 @@
 import ims.tiger.query.processor.CorpusQueryProcessor;
 
 public class TIGERSearchEngine extends SearchEngine {
-
+	
 	public static final String NAME = "TIGER";
-
+	
 	HashMap<CorpusBuild, TSCorpus> corpora = null;
-
+	
 	public TSCorpus getTSCorpus(CorpusBuild corpus) {
 		CorpusBuild root = corpus.getRootCorpusBuild();
 		TSCorpus tscorpus = corpora.get(root);
@@ -54,29 +55,30 @@
 		if (tscorpus != null) {
 			corpora.put(root, tscorpus);
 			return tscorpus;
-		} else {
+		}
+		else {
 			return null;
 		}
 	}
-
+	
 	public TSCorpus removeTSCorpus(CorpusBuild corpus) {
 		CorpusBuild root = corpus.getRootCorpusBuild();
 		return corpora.remove(root);
 	}
-
+	
 	@Override
 	public boolean isRunning() {
 		return true;
 	}
-
+	
 	@Override
 	public boolean initialize() throws Exception {
 		return true;
 	}
-
+	
 	/**
 	 * 
-	 * @param cqpCorpus the targeted CQPCorpus 
+	 * @param cqpCorpus the targeted CQPCorpus
 	 * @return the first sentence and last sentence id (from 0 to N, N the number of sentences). WARNING: this is not the list of sentences in the targeted CQPCorpus. unless the CQPcorpus is contigues
 	 * 
 	 * @throws UnexpectedAnswerException
@@ -87,15 +89,15 @@
 	public static int[] getSentMinMax(CQPCorpus cqpCorpus) throws UnexpectedAnswerException, IOException, CqiServerError, CqiClientException {
 		List<org.txm.searchengine.cqp.corpus.query.Match> matches = cqpCorpus.getMatches();
 		if (matches.size() == 0) {
-			return new int[]{0,0};
+			return new int[] { 0, 0 };
 		}
-
-		return getSentMinMax(cqpCorpus, matches.get(0).getStart(), matches.get(matches.size()-1).getEnd());
+		
+		return getSentMinMax(cqpCorpus, matches.get(0).getStart(), matches.get(matches.size() - 1).getEnd());
 	}
 	
 	/**
 	 * 
-	 * @param cqpCorpus the targeted CQPCorpus 
+	 * @param cqpCorpus the targeted CQPCorpus
 	 * @return the first sentence and last sentence id (from 0 to N, N the number of sentences). WARNING: this is not the list of sentences in the targeted CQPCorpus. unless the CQPcorpus is contigues
 	 * 
 	 * @throws UnexpectedAnswerException
@@ -107,32 +109,33 @@
 		AbstractCqiClient CQI = CQPSearchEngine.getCqiClient();
 		List<org.txm.searchengine.cqp.corpus.query.Match> matches = cqpCorpus.getMatches();
 		if (matches.size() == 0) {
-			return new int[]{0,0};
+			return new int[] { 0, 0 };
 		}
-		int[] cpos = new int[] {start, end};
+		int[] cpos = new int[] { start, end };
 		int[] structs = CQI.cpos2Struc(cqpCorpus.getStructuralUnit("s").getProperty("n").getQualifiedName(), cpos);
 		if (structs.length == 0) {
-			return new int[]{0,0};
+			return new int[] { 0, 0 };
 		}
 		int sent_min = structs[0];
-		int sent_max = structs[structs.length-1];
-		return new int[]{sent_min, sent_max};
+		int sent_max = structs[structs.length - 1];
+		return new int[] { sent_min, sent_max };
 	}
 	
 	/**
 	 * 
 	 * @return true because TIGER queries are frequently multi lines
 	 */
+	@Override
 	public boolean hasMultiLineQueries() {
 		return true;
 	}
-
+	
 	@Override
 	public boolean start(IProgressMonitor monitor) throws Exception {
-		corpora = new HashMap<CorpusBuild, TSCorpus>();
+		corpora = new HashMap<>();
 		return true;
 	}
-
+	
 	@Override
 	public boolean stop() throws Exception {
 		if (corpora != null) {
@@ -143,142 +146,150 @@
 		}
 		return true;
 	}
-
+	
 	@Override
 	public String getName() {
 		return NAME;
 	}
-
+	
 	@Override
 	public Selection query(CorpusBuild corpus, IQuery query, String name, boolean saveQuery) throws Exception {
-
+		
 		TSCorpus tcorpus = this.getTSCorpus(corpus);
 		TSResult result = null;
 		if (corpus == corpus.getRootCorpusBuild() || !(corpus instanceof CQPCorpus)) { // root corpus or something not a CQPCorpus
 			result = tcorpus.query(query.getQueryString().replace("\n", " "));
-		} else {
-			CQPCorpus cqpCorpus = (CQPCorpus)corpus;
+		}
+		else {
+			CQPCorpus cqpCorpus = (CQPCorpus) corpus;
 			AbstractCqiClient CQI = CQPSearchEngine.getCqiClient();
 			List<org.txm.searchengine.cqp.corpus.query.Match> matches = cqpCorpus.getMatches();
 			if (matches.size() == 0) {
 				return new EmptySelection(query);
 			}
-			int[] cpos = {matches.get(0).getStart(), matches.get(matches.size()-1).getEnd()};
+			int[] cpos = { matches.get(0).getStart(), matches.get(matches.size() - 1).getEnd() };
 			int[] structs = CQI.cpos2Struc(cqpCorpus.getStructuralUnit("s").getProperty("n").getQualifiedName(), cpos);
 			if (structs.length == 0) {
 				return new EmptySelection(query);
 			}
 			int sent_min = structs[0];
-			int sent_max = structs[structs.length-1];
-			Log.finest("QUERYING sentences: "+sent_min+" -> "+sent_max);
-			result = tcorpus.query(query.getQueryString().replace("\n", " "), sent_min, sent_max+1, -1);
+			int sent_max = structs[structs.length - 1];
+			Log.finest("QUERYING sentences: " + sent_min + " -> " + sent_max);
+			result = tcorpus.query(query.getQueryString().replace("\n", " "), sent_min, sent_max + 1, -1);
 		}
 		MatchResult mresult = result.getMatchResult();
 		int size = mresult.size();
-		//System.out.println("size: "+size);
+		// System.out.println("size: "+size);
 		int subsize = mresult.submatchSize();
 		if (size == 0 || subsize == 0) {
 			return new EmptySelection(query);
 		}
-
+		
 		Index index = tcorpus.getIndex();
-
+		
 		// compute sentence positions
-		//TODO move it to TSCorpus
+		// TODO move it to TSCorpus
 		int[] starts = tcorpus.getSentenceStartPositions();
-
-		LinkedHashSet<TIGERMatch> tigerMatchesList = new LinkedHashSet<TIGERMatch>();
-
+		
+		LinkedHashSet<TIGERMatch> tigerMatchesList = new LinkedHashSet<>();
+		
 		List<String> variables = java.util.Arrays.asList(mresult.getVariableNames());
-		//System.out.println("Variables: "+variables+" iPivot="+variables.indexOf("pivot"));
+		// System.out.println("Variables: "+variables+" iPivot="+variables.indexOf("pivot"));
 		int iPivot = variables.indexOf("pivot");
-
+		
 		MappedByteBuffer offsetsMapped = tcorpus.getOffsetsMapped();
-		//MappedByteBuffer offsetsMapped = tcorpus.getOffsetsMapped();
+		// MappedByteBuffer offsetsMapped = tcorpus.getOffsetsMapped();
 		
-		//System.out.println("submatchSize: "+subsize);
-		for (int imatch = 0 ; imatch < size; imatch++) { // the matching sentences
-			int sent = mresult.getSentenceNumberAt(imatch);
-			//Sentence sentence = tcorpus.manager.getSentence(sent);
-
-			//System.out.println(" sent: "+sent);
+		boolean useSubMatches = TIGERSearchPreferences.getInstance().getBoolean(TIGERSearchPreferences.USESUBMATCHES);
+		
+		// System.out.println("submatchSize: "+subsize);
+		for (int isentMatch = 0; isentMatch < size; isentMatch++) { // the matching sentences
+			int sent = mresult.getSentenceNumberAt(isentMatch);
+			// Sentence sentence = tcorpus.manager.getSentence(sent);
+			
+			// System.out.println(" sent: "+sent);
 			int sent_submatch = mresult.getSentenceSubmatchSize(sent);
-
-			//System.out.println(" sent submatch size: "+sent_submatch);
-			for (int isubmatch = 0 ; isubmatch < sent_submatch ; isubmatch++) { // the matches in the sentence
-				int[] match = mresult.getSentenceSubmatchAt(sent, isubmatch);
-
+			
+			// System.out.println(" sent submatch size: "+sent_submatch);
+			for (int iSubMatch = 0; iSubMatch < sent_submatch; iSubMatch++) { // the matches in the sentence
+				int[] match = mresult.getSentenceSubmatchAt(sent, iSubMatch);
+				
 				int sent_start = starts[sent];
-
-				//				System.out.println("  sent="+sent_start+ " matches="+Arrays.toString(match)+" ipivot="+iPivot);
-				for (int i = 0 ; i < match.length ; i++) {
-
+				
+				// System.out.println(" sent="+sent_start+ " matches="+Arrays.toString(match)+" ipivot="+iPivot);
+				for (int i = 0; i < match.length; i++) {
+					
 					if (iPivot != -1 && i != iPivot) continue; // skip match that are not 'pivot'
-
-					int left = sent_start+index.getLeftCorner(sent, match[i]);
+					
+					int left = sent_start + index.getLeftCorner(sent, match[i]);
 					if (offsetsMapped != null) { // the TIGER token is not in the CQP corpus
-						left += offsetsMapped.getInt(left*Integer.BYTES);
-						//						System.out.println("left="+left+" offset="+offsetsMapped.getInt(left*Integer.BYTES));
+						left += offsetsMapped.getInt(left * Integer.BYTES);
+						// System.out.println("left="+left+" offset="+offsetsMapped.getInt(left*Integer.BYTES));
 					}
-					int right = sent_start+index.getRightCorner(sent, match[i]);
+					int right = sent_start + index.getRightCorner(sent, match[i]);
 					if (offsetsMapped != null) { // the TIGER token is not in the CQP corpus
-						right += offsetsMapped.getInt(right*Integer.BYTES);
+						right += offsetsMapped.getInt(right * Integer.BYTES);
 					}
-					//System.out.println("   M="+match[i]+" ("+left+", "+right+")");
-
+					// System.out.println(" M="+match[i]+" ("+left+", "+right+")");
+					
 					TIGERMatch tigerMatch = new TIGERMatch(left, right);
-
-					//System.out.println("  ajusted="+(tigerMatch));
+					
+					// System.out.println(" ajusted="+(tigerMatch));
 					tigerMatchesList.add(tigerMatch);
+					
+					if (!useSubMatches) { // use only the first submatch
+						break;
+					}
 				}
 			}
 		}
-
-		//intersect with corpus matches
-		List<? extends Match> result2 = Match.intersect(corpus.getMatches(),  new ArrayList<TIGERMatch>(tigerMatchesList), true);
-
+		
+		// intersect with corpus matches
+		List<? extends Match> result2 = Match.intersect(corpus.getMatches(), new ArrayList<>(tigerMatchesList), true);
+		
 		return new TIGERSelection(query, result2);
 	}
-
+	
 	@Override
 	public IQuery newQuery() {
 		return new TIGERQuery();
 	}
-
+	
 	@Override
 	public boolean hasIndexes(CorpusBuild corpus) {
 		if (corpus == null) return false;
-
-		//TODO implement a corpora of TIGER corpus
+		
+		// TODO implement a corpora of TIGER corpus
 		CorpusBuild root = corpus.getRootCorpusBuild();
 		File buildDirectory = new File(root.getProjectDirectory(), "tiger");
-		return	new File(buildDirectory, "tigersearch.logprop").exists() && 
+		return new File(buildDirectory, "tigersearch.logprop").exists() &&
 				new File(buildDirectory, root.getID()).exists();
 	}
-
+	
 	@Override
 	public void notify(TXMResult r, String state) {
 		if (r instanceof MainCorpus && "clean".equals(state)) { // the CQP corpus has been deleted by the user
-			MainCorpus c = (MainCorpus)r;
-			File buildDirectory = new File(c.getProjectDirectory(), "tiger/"+c.getID());
+			MainCorpus c = (MainCorpus) r;
+			File buildDirectory = new File(c.getProjectDirectory(), "tiger/" + c.getID());
 			if (buildDirectory.exists()) {
 				DeleteDir.deleteDirectory(buildDirectory);
 			}
-		} else if (r instanceof Project && "clean".equals(state)) {  // the Project has been deleted by the user
-			Project c = (Project)r;
+		}
+		else if (r instanceof Project && "clean".equals(state)) {  // the Project has been deleted by the user
+			Project c = (Project) r;
 			File buildDirectory = new File(c.getProjectDirectory(), "tiger");
 			if (buildDirectory.exists()) {
 				DeleteDir.deleteDirectory(buildDirectory);
 			}
 		}
 	}
-
+	
 	@Override
 	public String getValueForProperty(Match match, SearchEngineProperty property) {
 		// TODO Auto-generated method stub
 		return null;
 	}
-
+	
 	@Override
 	public List<String> getValuesForProperty(Match match, SearchEngineProperty property) {
 		// TODO Auto-generated method stub
Index: tmp/org.txm.tigersearch.rcp/src/org/txm/tigersearch/rcp/preferences/TIGERSearchPreferences.java
===================================================================
--- tmp/org.txm.tigersearch.rcp/src/org/txm/tigersearch/rcp/preferences/TIGERSearchPreferences.java	(revision 3060)
+++ tmp/org.txm.tigersearch.rcp/src/org/txm/tigersearch/rcp/preferences/TIGERSearchPreferences.java	(revision 3061)
@@ -11,30 +11,34 @@
  *
  */
 public class TIGERSearchPreferences extends TXMPreferences {
-
-		
+	
+	
 	public static String VERSION = "version";
-
-
+	
+	public static String USESUBMATCHES = "use_sub_matches";
+	
+	
 	/**
 	 * Gets the instance.
+	 * 
 	 * @return the instance
 	 */
-	public static TXMPreferences getInstance()	{
+	public static TXMPreferences getInstance() {
 		if (!TXMPreferences.instances.containsKey(TIGERSearchPreferences.class)) {
 			new TIGERSearchPreferences();
 		}
 		return TXMPreferences.instances.get(TIGERSearchPreferences.class);
 	}
-
 	
+	
 	@Override
 	public void initializeDefaultPreferences() {
 		super.initializeDefaultPreferences();
 		
 		Preferences preferences = this.getDefaultPreferencesNode();
-//		preferences.putBoolean(GROUP_BY_TEXTS, true);
-//		preferences.putInt(METHOD, 2);
+		preferences.putBoolean(USESUBMATCHES, true);
+		// preferences.putBoolean(GROUP_BY_TEXTS, true);
+		// preferences.putInt(METHOD, 2);
 	}
 }
 
Index: tmp/org.txm.tigersearch.rcp/src/org/txm/tigersearch/editors/TIGERSearchEditor.java
===================================================================
--- tmp/org.txm.tigersearch.rcp/src/org/txm/tigersearch/editors/TIGERSearchEditor.java	(revision 3060)
+++ tmp/org.txm.tigersearch.rcp/src/org/txm/tigersearch/editors/TIGERSearchEditor.java	(revision 3061)
@@ -166,7 +166,6 @@
 		svgPanel = new SVGComposite(mainPanel, SWT.EMBEDDED | SWT.NO_BACKGROUND);
 		svgPanel.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
 		
-		initializeFields();
 		this.getTopToolbar().setVisible(COMPUTING_PARAMETERS_GROUP_ID, true);
 	}
 	
@@ -178,13 +177,13 @@
 		if (!registrydir.exists()) {
 			System.out.println("TIGERSearch corpus '" + id + "' has no TIGERSearch registry directory: " + registrydir);
 			queryArea.setText("TIGERSearch corpus '" + id + "' has no TIGERSearch registry directory: " + registrydir);
-			okButton.setEnabled(false);
+			// okButton.setEnabled(false);
 			return;
 		}
 		if (!registrydir.exists()) {
 			System.out.println("TIGERSearch corpus '" + id + "' has no TIGERSearch config file: " + configfile);
 			queryArea.setText("TIGERSearch corpus '" + id + "' has no TIGERSearch config file: " + configfile);
-			okButton.setEnabled(false);
+			// okButton.setEnabled(false);
 			return;
 		}
 		// String query = "#n:[cat = \"Obj\"] >* #m & arity(#n, 2, 10)";
@@ -287,6 +286,9 @@
 	
 	@Override
 	public void updateEditorFromResult(boolean update) {
+		if (update == false) {
+			initializeFields();
+		}
 		// final String query = queryArea.getText().trim();
 		// if (query.length() == 0) {
 		// System.out.println("No query, aborting.");
@@ -351,6 +353,8 @@
 		int sent = sentSpinner.getSelection() - 1;
 		int sub = subSpinner.getSelection() - 1;
 		
+		ts.setIndexAndSubIndex(sent, sub);
+		
 		if (ts == null) return false; // no result
 		if (!ts.isComputed()) return false;
 		
Index: tmp/org.txm.index.rcp/src/org/txm/index/rcp/handlers/SendIndexTo.java
===================================================================
--- tmp/org.txm.index.rcp/src/org/txm/index/rcp/handlers/SendIndexTo.java	(revision 3060)
+++ tmp/org.txm.index.rcp/src/org/txm/index/rcp/handlers/SendIndexTo.java	(revision 3061)
@@ -76,12 +76,12 @@
 		Index index = (Index) result;
 		CQPCorpus corpus = CQPCorpus.getFirstParentCorpus(index);
 		
-		
 		// TODO enable subcorpus from index query when the hidden subcorpus deletion will be managed or another system implemented (eg new SubCorpus(TXMResult result)
 		if (index.getQuery() instanceof CQLQuery && IndexPreferences.getInstance().getBoolean(IndexPreferences.LINK_USING_SUBCORPUS)) {
 			CQLQuery cqlQuery = (CQLQuery) index.getQuery();
 			if (cqlQuery == null || cqlQuery.isEmpty() || // no query
-					cqlQuery.getQueryString().equals("[]")) { // don't bother creating a subcorpus use the parent corpus
+					cqlQuery.getQueryString().equals("[]") ||
+					cqlQuery.getQueryString().equals(".*")) { // don't bother creating a subcorpus use the parent corpus
 				return corpus;
 			}
 			
Index: tmp/org.txm.groovy.core/src/java/org/txm/groovy/core/GroovyScriptedImportEngine.java
===================================================================
--- tmp/org.txm.groovy.core/src/java/org/txm/groovy/core/GroovyScriptedImportEngine.java	(revision 3060)
+++ tmp/org.txm.groovy.core/src/java/org/txm/groovy/core/GroovyScriptedImportEngine.java	(revision 3061)
@@ -113,12 +113,9 @@
 			binding.setProperty("readyToLoad", Boolean.FALSE); //$NON-NLS-1$
 			// System.out.println("script="+script);
 			
-			TokenizerClasses.reset();
-			if (!TokenizerClasses.loadFromProject(project.getPreferencesScope())) {
+			if (!new TokenizerClasses().loadFromProject(project.getPreferencesScope())) {
 				Log.severe("Error: failed to load tokenizer parameters");
 				monitor.done();
-				// if (basedir.exists()) basedir.renameTo(errorBinDirectory);
-				// if (tempBinDirectory.exists()) tempBinDirectory.renameTo(basedir);
 				return Status.CANCEL_STATUS;
 			}
 			
@@ -129,8 +126,6 @@
 			s.run(); // run the groovy import script
 			monitor.worked(90);
 			
-			TokenizerClasses.reset(); // restore default tokenizer classes
-			
 			Object ready = binding.getVariable("readyToLoad"); //$NON-NLS-1$
 			if (ready != null && ready instanceof Boolean) {
 				Boolean readyToLoad = (Boolean) ready;
Index: tmp/org.txm.groovy.core/src/groovy/org/txm/macro/table/Excel2XMLMacro.groovy
===================================================================
--- tmp/org.txm.groovy.core/src/groovy/org/txm/macro/table/Excel2XMLMacro.groovy	(revision 3060)
+++ tmp/org.txm.groovy.core/src/groovy/org/txm/macro/table/Excel2XMLMacro.groovy	(revision 3061)
@@ -3,6 +3,8 @@
 import org.kohsuke.args4j.*
 import groovy.transform.Field
 import java.nio.charset.Charset
+
+import org.txm.libs.msoffice.ReadExcel
 import org.txm.rcpapplication.swt.widget.parameters.*
 import org.txm.utils.*
 import javax.xml.stream.*
@@ -17,66 +19,36 @@
 
 def stringToIndent = { str -> org.txm.utils.AsciiUtils.buildAttributeId(org.txm.utils.AsciiUtils.convertNonAscii(str)).toLowerCase() }
 
-// from http://www.java-connect.com/apache-poi-tutorials/read-all-type-of-excel-cell-value-as-string-using-poi
-def getCellValueAsString = { cell ->
-        strCellValue = null
-        if (cell != null) {
-            switch (cell.getCellType()) {
-            case CellType.STRING:
-                strCellValue = cell.toString()
-                break
-            case CellType.NUMERIC:
-                if (DateUtil.isCellDateFormatted(cell)) {
-                    SimpleDateFormat dateFormat = new SimpleDateFormat("dd/MM/yyyy")
-                    strCellValue = dateFormat.format(cell.getDateCellValue())
-                } else {
-                    value = cell.getNumericCellValue()
-                    longValue = value.longValue()
-                    strCellValue = new String(longValue.toString())
-                }
-                break
-            case CellType.BOOLEAN:
-                strCellValue = new String(new Boolean(cell.getBooleanCellValue()).toString())
-                break
-            case CellType.BLANK:
-                strCellValue = ""
-                break
-            }
-        }
-        if (strCellValue == null) strCellValue = ""
-        return strCellValue
-}
-
 @Field @Option(name="inputFile", usage="fichier Excel à traiter", widget="File", required=true, def="")
-File inputFile
+		File inputFile
 
 @Field @Option(name="sheetName", usage="sheet name (if no name is given the first sheet will be used)", widget="String", required=false, def="")
-def sheetName
+		def sheetName
 
 @Field @Option(name="rootTag", usage="root tag name", widget="String", required=false, def="root")
-def rootTag
+		def rootTag
 
 @Field @Option(name="textTag", usage="line unit tag name", widget="String", required=false, def="unit")
-def textTag
+		def textTag
 
 @Field @Option(name="metadataColumnList", usage="metadata columns list separated by comma", widget="String", required=false, def="meta1,meta2")
-def metadataColumnList
+		def metadataColumnList
 
 @Field @Option(name="dateColumnList", usage="date columns list separated by comma", widget="String", required=false, def="meta1,meta2")
-def dateColumnList
+		def dateColumnList
 
 @Field @Option(name="textColumnList", usage="text columns list separated by comma", widget="String", required=false, def="textColumnList1,textColumnList2")
-def textColumnList
+		def textColumnList
 
 @Field @Option(name="EmbedInTEI", usage="text columns list separated by comma", widget="Boolean", required=false, def="false")
-def EmbedInTEI
+		def EmbedInTEI
 
 if (!ParametersDialog.open(this)) return
 
-if (!inputFile.exists()) {
-	println "** Excel2XML: no '"+inputFile.name+"' file found. Aborting."
-	return false
-}
+	if (!inputFile.exists()) {
+		println "** Excel2XML: no '"+inputFile.name+"' file found. Aborting."
+		return false
+	}
 
 if (!inputFile.canRead()) {
 	println "** Excel2XML: '"+inputFile.name+"' file not readable. Aborting."
@@ -84,158 +56,132 @@
 }
 
 try {
-
-metadataColumnList = metadataColumnList.split(",").collect { it.trim() }
-dateColumnList = dateColumnList.split(",").collect { it.trim() }
-textColumnList = textColumnList.split(",").collect { it.trim() }
-textTag = textTag.trim()
-rootTag = rootTag.trim()
-
-wb = WorkbookFactory.create(inputFile)
-
-if (sheetName.length() == 0) {
-	ws = wb.getSheetAt(0)
-} else {
-	ws = wb.getSheet(sheetName)
-	if (ws == null) {
-		println "** Excel2XML: no '"+sheetName+" found. Aborting."
-		return false
+	
+	metadataColumnList = metadataColumnList.split(",").collect { it.trim() }
+	dateColumnList = dateColumnList.split(",").collect { it.trim() }
+	textColumnList = textColumnList.split(",").collect { it.trim() }
+	textTag = textTag.trim()
+	rootTag = rootTag.trim()
+	
+	ReadExcel excel = new ReadExcel(inputFile, sheetName);
+	excel.readHeaders();
+	
+	headers = excel.getHeaders()
+	
+	println "Headers: $headers"
+	
+	ok = true
+	metadataColumnList.each { m ->
+		if (!headers.contains(m)) {
+			println "** Excel2XML: missing metadataColumnList column: $m"
+			ok = false
+		}
 	}
-}
-
-if (ws == null) {
-	println "** Excel2XML: no sheet found. Aborting."
-	return false
-}
-
-nRows = ws.getPhysicalNumberOfRows()
-println nRows+" rows."
- 
-firstRow = ws.getRow(0)
-colMax = firstRow.getLastCellNum()
-
-headers = (0..colMax-1).collect { getCellValueAsString(firstRow.getCell(it)) }
-
-println "Headers: $headers"
-
-normalizedHeaders = headers.collect { stringToIndent(it) }
-
-ok = true
-metadataColumnList.each { m ->
-	if (!headers.contains(m)) {
-		println "** Excel2XML: missing metadataColumnList column: $m"
-		ok = false
+	textColumnList.each { t ->
+		if (!headers.contains(t)) {
+			println "** Excel2XML: missing textColumnList column: $t"
+			ok = false
+		}
 	}
-}
-textColumnList.each { t ->
-	if (!headers.contains(t)) {
-		println "** Excel2XML: missing textColumnList column: $t"
-		ok = false
-	}
-}
-
-if (!ok) { return false }
-
-metadataColumnIndex = metadataColumnList.collect { headers.indexOf(it) }
-dateColumnsIndex = dateColumnList.collect { headers.indexOf(it) }
-textColumnIndex = textColumnList.collect { headers.indexOf(it) }
-
-println "metadataColumnList = "+metadataColumnList
-println "metadataColumnIndex = "+metadataColumnIndex
-
-println "dateColumnList = "+dateColumnList
-println "dateColumnsIndex = "+dateColumnsIndex
-
-println "textColumnList = "+textColumnList
-println "textColumnIndex = "+textColumnIndex
-
-name = inputFile.getName()
-idx = name.lastIndexOf(".")
-
-if (idx > 0) name = name.substring(0, idx)
-outputFile = new File(inputFile.getParentFile(), name+".xml")
-
-factory = XMLOutputFactory.newInstance()
-output = new FileOutputStream(outputFile)
-writer = factory.createXMLStreamWriter(output, "UTF-8")
-
-writer.writeStartDocument("UTF-8","1.0")
-writer.writeCharacters("\n") // simple XML formating
-
-if (EmbedInTEI) {
-	writer.writeStartElement("TEI")
-	writer.writeStartElement("teiHeader")
-	writer.writeEndElement() // teiHeader
-	writer.writeStartElement("text")
-	writer.writeCharacters("\n")
-}
-
-writer.writeStartElement(rootTag)
-writer.writeCharacters("\n")
-
-pb_n = 1
-
-(1..nRows-1).each { rowIndex ->
-
-	writer.writeCharacters("  ")
-	writer.writeEmptyElement("pb") // <pb/> to get one page per input line (don't forget high number of words per page in import module)
-	writer.writeAttribute("n", ""+pb_n++)
+	
+	if (!ok) { return false }
+	
+	println "metadataColumnList = "+metadataColumnList
+	println "dateColumnList = "+dateColumnList
+	println "textColumnList = "+textColumnList
+	
+	name = inputFile.getName()
+	idx = name.lastIndexOf(".")
+	
+	if (idx > 0) name = name.substring(0, idx)
+	outputFile = new File(inputFile.getParentFile(), name+".xml")
+	
+	factory = XMLOutputFactory.newInstance()
+	output = new FileOutputStream(outputFile)
+	writer = factory.createXMLStreamWriter(output, "UTF-8")
+	
+	writer.writeStartDocument("UTF-8","1.0")
 	writer.writeCharacters("\n") // simple XML formating
-
-	writer.writeCharacters("  ")
-	writer.writeStartElement(textTag)
-	metadataColumnIndex.each { colIndex -> // build an attribute for each metadata
-		def row = ws.getRow(rowIndex)
-		if (row != null) {
-		String s = getCellValueAsString(row.getCell(colIndex));
-		if (s == null) s ="";
-		value = s.replaceAll("\n", ";").trim()
-		writer.writeAttribute(normalizedHeaders[colIndex], value)
-		if (colIndex in dateColumnsIndex) { // also split date attributes in day+month+year attributes
-			matches = (value =~ /([0-9]{2})\/([0-9]{2})\/([0-9]{4})/)
-			writer.writeAttribute(normalizedHeaders[colIndex]+"jour", matches[0][1])
-			writer.writeAttribute(normalizedHeaders[colIndex]+"joursemaine", new java.text.SimpleDateFormat('EEEE').format(Date.parse("dd/MM/yyyy", value)))
-			writer.writeAttribute(normalizedHeaders[colIndex]+"mois", matches[0][2])
-			writer.writeAttribute(normalizedHeaders[colIndex]+"annee", matches[0][3])
-		}
-		}
+	
+	if (EmbedInTEI) {
+		writer.writeStartElement("TEI")
+		writer.writeStartElement("teiHeader")
+		writer.writeEndElement() // teiHeader
+		writer.writeStartElement("text")
+		writer.writeCharacters("\n")
 	}
+	
+	writer.writeStartElement(rootTag)
 	writer.writeCharacters("\n")
-
-	writer.writeCharacters("    ")
-	writer.writeStartElement("metadata")
-	writer.writeStartElement("list")
-	writer.writeAttribute("type", "unordered")
-	writer.writeCharacters("\n")
-
- 	metadataColumnIndex.each { colIndex ->
- 		writer.writeStartElement("item")
- 		def row = ws.getRow(rowIndex)
- 		if (row != null) {
- 			writer.writeCharacters(headers[colIndex]+" : "+getCellValueAsString(row.getCell(colIndex)).replaceAll("\n", ";"))
+	
+	pb_n = 1
+	
+	//(1..nRows-1).each { rowIndex ->
+	def record = null
+	while (excel.readRecord()) {
+		
+		record = excel.getRecord()
+		if (record.isEmpty()) continue;
+		
+		//println "record=$record"
+		
+		writer.writeCharacters("  ")
+		writer.writeEmptyElement("pb") // <pb/> to get one page per input line (don't forget high number of words per page in import module)
+		writer.writeAttribute("n", ""+pb_n++)
+		writer.writeCharacters("\n") // simple XML formating
+		
+		writer.writeCharacters("  ")
+		writer.writeStartElement(textTag)
+		//metadataColumnIndex.each { colIndex -> // build an attribute for each metadata
+		for (def metadataName : metadataColumnList) {
+			String s = record.get(metadataName);
+			if (s == null) s = "";
+			
+			value = s.replaceAll("\n", ";").trim()
+			writer.writeAttribute(stringToIndent(metadataName), value)
+			
+			if (metadataName in dateColumnList) { // also split date attributes in day+month+year attributes
+				matches = (value =~ /([0-9]{2})\/([0-9]{2})\/([0-9]{4})/)
+				writer.writeAttribute(metadataName+"-jour", matches[0][1])
+				writer.writeAttribute(metadataName+"-joursemaine", new java.text.SimpleDateFormat('EEEE').format(Date.parse("dd/MM/yyyy", value)))
+				writer.writeAttribute(metadataName+"-mois", matches[0][2])
+				writer.writeAttribute(metadataName+"-annee", matches[0][3])
+			}
+		}
+		writer.writeCharacters("\n")
+		
+		writer.writeCharacters("    ")
+		writer.writeStartElement("metadata")
+		writer.writeStartElement("list")
+		writer.writeAttribute("type", "unordered")
+		writer.writeCharacters("\n")
+		
+		//metadataColumnIndex.each { colIndex ->
+		for (def metadataName : metadataColumnList) {
+			writer.writeStartElement("item")
+			writer.writeCharacters(metadataName+" : "+record.get(metadataName).replaceAll("\n", ";"))
 			writer.writeEndElement() // item
 			writer.writeCharacters("\n")
 		}
-	}
-	writer.writeCharacters("    ")
-	writer.writeEndElement() // list
-	writer.writeEndElement() // head
-	writer.writeCharacters("\n")
-
-   	textColumnIndex.each { colIndex ->
-		
-    	writer.writeCharacters("    ")
-    	writer.writeStartElement(normalizedHeaders[colIndex])
-		writer.writeStartElement("p")
-		writer.writeStartElement("head")
-		writer.writeStartElement("hi")
-		writer.writeCharacters(headers[colIndex]+" : ")
-		writer.writeEndElement() // hi
+		writer.writeCharacters("    ")
+		writer.writeEndElement() // list
 		writer.writeEndElement() // head
-		def row = ws.getRow(rowIndex)
-		if (row != null) {
-			value = getCellValueAsString(row.getCell(colIndex))
-
+		writer.writeCharacters("\n")
+		
+		//textColumnIndex.each { colIndex ->
+		for (def textColumnName : textColumnList) {
+			
+			writer.writeCharacters("    ")
+			writer.writeStartElement(stringToIndent(textColumnName))
+			writer.writeStartElement("p")
+			writer.writeStartElement("head")
+			writer.writeStartElement("hi")
+			writer.writeCharacters(textColumnName+" : ")
+			writer.writeEndElement() // hi
+			writer.writeEndElement() // head
+			
+			value = record.get(textColumnName)
+				
 			if (value ==~ /(?s)^[A-Z]{3}:  [^;\n]+? +[;\n].*/) {
 				value.findAll( /(?s)[A-Z]{3}:  ([^;\n]+?) +[;\n]/ ).each { desc ->
 					writer.writeStartElement("descripteur")
@@ -251,25 +197,26 @@
 			writer.writeEndElement() // textColumn
 			writer.writeCharacters("\n")
 		}
+		
+		writer.writeCharacters("  ")
+		writer.writeEndElement() // textTag
+		writer.writeCharacters("\n")
 	}
-
-	writer.writeCharacters("  ")
-	writer.writeEndElement() // textTag
+	
+	writer.writeEndElement() // rootTag
 	writer.writeCharacters("\n")
-}
-
-writer.writeEndElement() // rootTag
-writer.writeCharacters("\n")
-if (EmbedInTEI) {
-	writer.writeEndElement() // text
-	writer.writeCharacters("\n")
-	writer.writeEndElement() // TEI
-	writer.writeCharacters("\n")
-}
-writer.close()
-output.close()
-println "Result file: $outputFile"
-
+	
+	if (EmbedInTEI) {
+		writer.writeEndElement() // text
+		writer.writeCharacters("\n")
+		writer.writeEndElement() // TEI
+		writer.writeCharacters("\n")
+	}
+	
+	writer.close()
+	output.close()
+	println "Result file: $outputFile"
+	
 } catch (Exception e) {
 	println "** Excel2XML: unable to read input file. Aborting."
 	println e.getLocalizedMessage()
